/*
	 []---------------------------------------------------------[]
	 |                            T2H.C                          |
	 |                                                           |
	 |    Converte um arquivo texto em tabelas no formato HTML   |
	 |                                                           |
	 |  (C) 1998, Lenimar Nunes de Andrade, lenimar@mat.ufpb.br  |
	 |                                                           |
	 []---------------------------------------------------------[]
*/

#include <stdio.h>
#include <string.h>
#include <dir.h>
#include <stdlib.h>
#include <ctype.h>

#define NOME_BASE  "DADOS"
#define CAR         254
#define MAXPROVAS   6

#define boolean  int
#define VERDADEIRO 1
#define FALSO      0

float SOMA = 0.0;               /* Soma das notas                */
int   QUANT = 0,                /* Quantidade de alunos          */
      QUANT_7_10 = 0,           /* Alunos com nota de 7 a 10     */
      QUANT_4_7 = 0,            /* Alunos com nota de 4 a  7     */
      QUANT_0_4 = 0,            /* Alunos com nota de 0 a  4     */
      LINHAS_NO_CABECALHO = 5,  /* Numero de linhas no cabecalho */
      PROVA = 1,                /* Numero da prova               */
      ESPACAMENTO = 3,          /* Espacos em branco na moldura  */
      MOLDURA = 1,              /* Define se mostra moldura      */
      LARGURA = 60,             /* Largura da tabela             */
      QUANT_FALTOU = 0;         /* Quantidade de faltosos        */

char COR_FUNDO[10] =  "FFFFFF",
     COR_TABELA[10] = "AAEEFF",
     COR_TEXTO[10] =  "000000",
     TIPO_DE_LETRA[30] = "helvetica";

/* ------------------------------------------------------------------------ */

typedef struct {
  char periodo[5];
  char professor[35];
  char departamento[80];
  char centro[8];
  char sexo;
  char sala[10];
  char turno[20];
  int  ultimoAlunoSalvo;
  int  quantidadeDeAlunos;
  int  quantidadeDeProvas;
  int  quantProvasJaRealizadas;
  char nome_da_disciplina[50];
  char nome_da_disc_abrev[50];
  char data[MAXPROVAS][15];
  int  turma;
  boolean iniciaisMaiusculas;
  boolean entrarLogoNotas;
  boolean reposicao;
  boolean eliminaMenorNota;
  boolean protejida;
  boolean semestreJaEncerrado;
  char senha[10];
  float versao;
} t_turma;

typedef struct {
  char nome[35];         /* Nome do aluno                     */
  char matricula[10];    /* Matricula do aluno                */
  int numero;            /* Numero de ordem do aluno na turma */
  int curso;             /* Numero do curso                   */
  int turma;             /* Numero da turma                   */
  float nota[MAXPROVAS]; /* Notas do aluno                    */
} t_aluno;

#define TAMANHO(s, tam)       tam = 0; if (s[0]) while(s[++tam])

extern unsigned _stklen = 50000U;

/* ----------------------------------------------------------------------- */

/* Compara os n primeiros caracteres dos strings s1 e s2. Retorna 1 se
   forem identicos ou 0 forem distintos. Nao  e' feita distincao entre
   letras maiusculas e as respectivas letras minusculas.
   Ex.: COMPSTRNI("teste", "teste2...", 5) = 1
	COMPSTRNI("teste", "TESTE2...", 5) = 1                  */

#define COMPSTRNI(s1, s2, n) (ComparaNI(s1, s2, n) < 0)

/* ----------------------------------------------------------------------- */

int ComparaNI(char *s1, char *s2, int n) {

/* Compara os n primeiros caracteres dos strings  s1  e  s2 e retorna a
   posicao dos primeiros caracteres que forem diferentes. Retorna -1 se
   os strings coincidirem nos n primeiros caracteres. Letras maiusculas
   sao consideradas identicas `as respectivas letras minusculas.
   Ex.: ComparaN("um", "dois", 10) = 0
	ComparaN("teste", "TESTE", 4) = -1
	ComparaN("Alo", "Alo!!!", 5) = 3
	ComparaN("Alo", "Alo!!!", 3) = -1     */

  register int i = 0;

  while (i < n && s1[i] != '\0' && s2[i] != '\0' &&
				    toupper(s1[i]) == toupper(s2[i])) i++;
  if (i == n || (s1[i] == '\0' && s2[i] == '\0')) return -1;
  else return i;
}

/* ----------------------------------------------------------------------- */

float LeNotaNoArquivo(FILE *arq, long int rec) {

  t_aluno aluno;

  fseek(arq, rec*sizeof(t_aluno), 0);
  if (fread(&aluno, sizeof(t_aluno), 1, arq))
    return aluno.nota[PROVA - 1];
  else
    return -1.0;
}

/* ----------------------------------------------------------------------- */

char nomealuno[150];

char *LeNomeNoArquivo(FILE *arq, long int rec) {

  t_aluno aluno;

  fseek(arq, rec*sizeof(t_aluno), 0);
  if (fread(&aluno, sizeof(t_aluno), 1, arq)) {
    strcpy(nomealuno, aluno.nome);
    return nomealuno;
  } else
    return NULL;
}

/* ----------------------------------------------------------------------- */

void TrocaItensNoArquivo(FILE *arq, long int i, long int j) {

  char a[sizeof(t_aluno)], b[sizeof(t_aluno)];

  fseek(arq, sizeof(t_aluno)*i, 0);
  fread(a, sizeof(t_aluno), 1, arq);
  fseek(arq, sizeof(t_aluno)*j, 0);
  fread(b, sizeof(t_aluno), 1, arq);

  fseek(arq, sizeof(t_aluno)*j, 0);
  fwrite(a, sizeof(t_aluno), 1, arq);
  fseek(arq, sizeof(t_aluno)*i, 0);
  fwrite(b, sizeof(t_aluno), 1, arq);
}

/* ----------------------------------------------------------------------- */

void qs_disco1(FILE *arq, int esquerda, int direita) {

  long int i, j;
  float x;

  i = esquerda; j = direita;

  x = LeNotaNoArquivo(arq, (long int) (i + j)/2);

  do {
    while(LeNotaNoArquivo(arq, i) > x && i < direita) i++;
    while(LeNotaNoArquivo(arq, j) < x && j > esquerda) j--;
    if (i <= j) {
      TrocaItensNoArquivo(arq, i, j);
      i++; j--;
    }
  } while (i <= j);
  if (esquerda < j) qs_disco1(arq, esquerda, (int) j);
  if (i < direita)  qs_disco1(arq, (int) i, direita);
}

/* ----------------------------------------------------------------------- */

void qs_disco2(FILE *arq, int esquerda, int direita) {

  long int i, j;
  char x[150];

  i = esquerda; j = direita;

  strcpy(x, LeNomeNoArquivo(arq, (long int) (i + j)/2));

  do {
    while(strnicmp(LeNomeNoArquivo(arq, i), x, 100) < 0 && i < direita) i++;
    while(strnicmp(LeNomeNoArquivo(arq, j), x, 100) > 0 && j > esquerda) j--;
    if (i <= j) {
      TrocaItensNoArquivo(arq, i, j);
      i++; j--;
    }
  } while (i <= j);
  if (esquerda < j) qs_disco2(arq, esquerda, (int) j);
  if (i < direita)  qs_disco2(arq, (int) i, direita);
}

/* ----------------------------------------------------------------------- */

void quick_disco_decres(char *nome_arq, int quant) {

  FILE *arq;

  arq = fopen(nome_arq, "r+");
  if (arq == NULL) {
    printf("\a\n\nERRO: arquivo %s nao pode ser aberto.\n", nome_arq);
    return;
  }
  qs_disco1(arq, 0, quant - 1);
  fclose(arq);
}

/* ----------------------------------------------------------------------- */

void quick_disco_alfa(char *nome_arq, int quant) {

  FILE *arq;

  arq = fopen(nome_arq, "r+");
  if (arq == NULL) {
    printf("\a\n\nERRO: arquivo %s nao pode ser aberto.\n", nome_arq);
    return;
  }
  qs_disco2(arq, 0, quant - 1);
  fclose(arq);
}

/* ----------------------------------------------------------------------- */

int QuantosItens(char *nome) {

  struct ffblk info;

  findfirst(nome, &info, 0);
  return (int) (info.ff_fsize/sizeof(t_aluno));
}

/* ------------------------------------------------------------------------ */

char *Maiusculas(char *s) {

/* Converte o string s para letras maiusculas.
   Ex.: Maiusculas("Guizinha") = "GUIZINHA"      */

  int i = 0;
  while(s[i]) {
    if (s[i] >= 'a' && s[i] <= 'z') s[i] -= 32;
    i++;
  }
  return s;
}

/* ------------------------------------------------------------------------ */

char *Substr(char *s, int inicio, int fim) {

/* Retorna um substring de um string s.
   Ex.: Substr("Joao Pessoa", 5, 8) = "Pess"    */

  register int i, tam;

  if (inicio > fim) return NULL;
  if (inicio < 0) inicio = 0;
  TAMANHO(s, tam);
  if (fim >= tam) fim = tam - 1;

  i = inicio;
  while (i <= fim) s[i - inicio] = s[i++];
  s[i - inicio] = '\0';
  return s;
}

/* ------------------------------------------------------------------------ */

int Pos(char x, char *s) {

/* Retorna a primeira posicao do caracter x no string s. Retorna -1 se
   x nao pertencer a s.
   Ex.: Pos('a', "Matematica") = 1           */

  register int i;

  for(i = 0; s[i]; i++)
    if (s[i] == x) return i;
  return -1;
}

/* ------------------------------------------------------------------------ */

void CriaArquivoEmOrdemAlfabetica(char *nome_saida) {

  FILE *txt, *html, *arq_dados, *arq_turma;
  t_turma turma;
  t_aluno aluno;
  char ArqTurma[100], ArqDados[100], ArqHtml[100], ArqTexto[100];
  int quant;

  sprintf(ArqHtml, "%s1.htm", nome_saida);
  sprintf(ArqTexto, "%s1.txt", nome_saida);
  sprintf(ArqTurma, "%s.tur", NOME_BASE);
  sprintf(ArqDados, "%s.dat", NOME_BASE);

  quant = QuantosItens(ArqDados);
  quick_disco_alfa(ArqDados, quant);

  if ((html = fopen(ArqHtml, "wt")) == NULL) {
    printf("\nERRO: arquivo %s nao pode ser aberto.\n", ArqHtml);
    return;
  }
  if ((txt = fopen(ArqTexto, "wt")) == NULL) {
    printf("\nERRO: arquivo %s nao pode ser aberto.\n", ArqTexto);
    return;
  }
  if ((arq_turma = fopen(ArqTurma, "rb")) == NULL) {
    printf("\nERRO: arquivo %s nao pode ser aberto.\n", ArqTurma);
    return;
  }
  if ((arq_dados = fopen(ArqDados, "rb")) == NULL) {
    printf("\nERRO: arquivo %s nao pode ser aberto.\n", ArqDados);
    return;
  }

  fread(&turma, sizeof(t_turma), 1, arq_turma);
  fclose(arq_turma);
  fprintf(html, "<!-- T2H - Conversao de arquivo texto em tabelas em HTML>\n");
  fprintf(html, "<!-- (C) 1998, Lenimar N. Andrade - lenimar@mat.ufpb.br>\n\n");
  fprintf(html, "<!-- Nomes dos alunos em ordem alfabetica>");

  fprintf(html, "\n\n<html>\n<body bgcolor = #%s>\n<center>", COR_FUNDO);
  fprintf(html, "\n<title>Notas de %s</title>", turma.nome_da_disciplina);
  fprintf(html, "\n\n<font face = %s color = #%s>\n"
	 "%s<br>\n%s\n", TIPO_DE_LETRA, COR_TEXTO, turma.departamento,
	  turma.nome_da_disciplina);
  fprintf(html, "<br>%d<sup><u>a</u></sup> prova -- "
		"Turma %d -- Sala %s -- Hor&aacute;rio %s", PROVA,
		turma.turma, turma.sala, turma.turno);
  fprintf(html, "\n<br>Prof. %s<br><br>", turma.professor);
  fprintf(html,  "\n\n<table border=%d cellspacing=%d cols=%d width=%d%c "
		    "bgcolor = #%s>\n", MOLDURA, ESPACAMENTO, ESPACAMENTO,
		  LARGURA, 37, COR_TABELA);
  fprintf(txt, "\n%s\n%s", turma.departamento, turma.nome_da_disciplina);
  fprintf(txt, "\n%da. prova -- Turma %d -- Sala %s -- Horario %s", PROVA,
		turma.turma, turma.sala, turma.turno);
  fprintf(txt, "\nProf. %s\n", turma.professor);
  fprintf(txt, "\nMATRIC                 NOME              NOTA ");
  fprintf(txt, "\n-------  ------------------------------- ----");
  fprintf(html, "\n<tr><td align=center> <font size=-2 color = #%s> "
	  "MATR&Iacute;CULA\n </td>"
	"<td align=center><font size=-2 color = #%s> NOME\n </td>"
	"<td align=center> <font size=-2 color = #%s> NOTA </td></tr>\n",
	COR_TEXTO, COR_TEXTO, COR_TEXTO);

  while (fread(&aluno, sizeof(t_aluno), 1, arq_dados) == 1) {
    fprintf(txt, "\n%s  %-30s %5.1f", aluno.matricula,
					    aluno.nome, aluno.nota[PROVA - 1]);
    fprintf(html,"\n<tr><td align=center><font face = %s color = %s> %s </td>"
	 "<td align=left> <font face = %s color = %s>\n"
	 " %s </td><td align=right> <font face = %s color=%s>%5.1f </td></tr>",
	 TIPO_DE_LETRA, COR_TEXTO, aluno.matricula, TIPO_DE_LETRA, COR_TEXTO,
	   aluno.nome, TIPO_DE_LETRA, COR_TEXTO, aluno.nota[PROVA - 1]);
  }
  fprintf(html, "\n\n</table>\n</center>\n</body>\n</html>\n");

  fprintf(txt, "\n\nMedia das notas da prova: %5.2f", SOMA/((float) QUANT));
  if (QUANT_FALTOU)
    fprintf(txt, "\nTotal de alunos que faltaram `a prova: %d", QUANT_FALTOU);
  fprintf(txt, "\nTotal de alunos que compareceram `a prova: %d", QUANT);
  fprintf(txt, "\n  %2d alunos (%5.2f%c) com nota igual ou superior a 7.0",
		      QUANT_7_10, (100.0*QUANT_7_10)/((float) QUANT), 37);
  fprintf(txt, "\n  %2d alunos (%5.2f%c) com nota igual ou superior a 4.0 e"
	  " inferior a 7.0", QUANT_4_7, (100.0*QUANT_4_7)/((float) QUANT), 37);
  fprintf(txt, "\n  %2d alunos (%5.2f%c) com nota inferior a 4.0",
		      QUANT_0_4, (100.0*QUANT_0_4)/((float) QUANT), 37);
  fclose(arq_dados);
  fclose(html);
  fclose(txt);

  printf("\n%c Arquivo %s criado (ordem alfabetica)", CAR, ArqTexto);
  printf("\n%c Arquivo %s criado (ordem alfabetica)", CAR, ArqHtml);
}

/* ---------------------------------------------------------------------- */

void CriaArquivoEmOrdemDecrescente(char *nome_saida) {

  FILE *txt, *html, *arq_dados, *arq_turma;
  t_turma turma;
  t_aluno aluno;
  char ArqTurma[100], ArqDados[100], ArqHtml[100], ArqTexto[100];
  int quant;

  sprintf(ArqHtml, "%s2.htm", nome_saida);
  sprintf(ArqTexto, "%s2.txt", nome_saida);
  sprintf(ArqTurma, "%s.tur", NOME_BASE);
  sprintf(ArqDados, "%s.dat", NOME_BASE);

  quant = QuantosItens(ArqDados);
  quick_disco_decres(ArqDados, quant);

  if ((html = fopen(ArqHtml, "wt")) == NULL) {
    printf("\nERRO: arquivo %s nao pode ser aberto.\n", ArqHtml);
    return;
  }
  if ((txt = fopen(ArqTexto, "wt")) == NULL) {
    printf("\nERRO: arquivo %s nao pode ser aberto.\n", ArqTexto);
    return;
  }
  if ((arq_turma = fopen(ArqTurma, "rb")) == NULL) {
    printf("\nERRO: arquivo %s nao pode ser aberto.\n", ArqTurma);
    return;
  }
  if ((arq_dados = fopen(ArqDados, "rb")) == NULL) {
    printf("\nERRO: arquivo %s nao pode ser aberto.\n", ArqDados);
    return;
  }

  fread(&turma, sizeof(t_turma), 1, arq_turma);
  fclose(arq_turma);
  fprintf(html, "<!-- T2H - Conversao de arquivo texto em tabelas em HTML>\n");
  fprintf(html, "<!-- (C) 1998, Lenimar N. Andrade - lenimar@mat.ufpb.br>\n\n");
  fprintf(html, "<!-- Notas em ordem decrescente>");
  fprintf(html, "\n\n<html>\n<body bgcolor = #%s>\n<center>", COR_FUNDO);
  fprintf(html, "\n<title>Notas de %s</title>", turma.nome_da_disciplina);
  fprintf(html, "\n\n<font face = %s color = #%s>\n"
     "%s<br>\n%s\n", TIPO_DE_LETRA, COR_TEXTO, turma.departamento,
						 turma.nome_da_disciplina);
  fprintf(html, "<br>%d<sup><u>a</u></sup> prova -- Turma %d -- "
		"Sala %s -- Hor&aacute;rio %s", PROVA,
		turma.turma, turma.sala, turma.turno);
  fprintf(html, "\n<br>Prof. %s<br><br>", turma.professor);
  fprintf(html, "\n\n<table border=%d cellspacing=%d cols=%d " \
		   "width=%d%c bgcolor = #%s>\n", MOLDURA,
		    ESPACAMENTO, ESPACAMENTO, LARGURA, 37, COR_TABELA);

  fprintf(txt, "\n%s\n%s", turma.departamento,
						turma.nome_da_disciplina);
  fprintf(txt, "\n%da. prova -- Turma %d -- Sala %s -- Horario %s", PROVA,
		turma.turma, turma.sala, turma.turno);
  fprintf(txt, "\nProf. %s\n", turma.professor);
  fprintf(txt, "\nMATRIC                 NOME              NOTA ");
  fprintf(txt, "\n-------  ------------------------------- ----");
  fprintf(html, "\n<tr><td align=center> <font size=-2 color = #%s> "
	"MATR&Iacute;CULA\n </td>"
	"<td align=center><font size=-2 color = #%s> NOME\n </td>"
	"<td align=center> <font size=-2 color = #%s> NOTA </td></tr>\n",
					    COR_TEXTO, COR_TEXTO, COR_TEXTO);

  while (fread(&aluno, sizeof(t_aluno), 1, arq_dados) == 1) {
    fprintf(txt, "\n%s  %-30s %5.1f", aluno.matricula, aluno.nome,
						 aluno.nota[PROVA - 1]);
    fprintf(html,"\n<tr><td align=center><font face = %s color = %s> %s </td>"
    "<td align=left> <font face = %s color = %s>\n"
    " %s </td><td align=right> <font face = %s color=%s>%5.1f </td></tr>",
    TIPO_DE_LETRA, COR_TEXTO, aluno.matricula, TIPO_DE_LETRA, COR_TEXTO,
    aluno.nome, TIPO_DE_LETRA, COR_TEXTO, aluno.nota[PROVA - 1]);

  }
  fprintf(html, "\n\n</table>\n</center>\n</body>\n</html>\n");


  fprintf(txt, "\n\nMedia das notas da prova: %5.2f", SOMA/((float) QUANT));
  if (QUANT_FALTOU)
    fprintf(txt, "\nTotal de alunos que faltaram `a prova: %d", QUANT_FALTOU);
  fprintf(txt, "\nTotal de alunos que compareceram `a prova: %d", QUANT);
  fprintf(txt, "\n  %2d alunos (%5.2f%c) com nota igual ou superior a 7.0",
		      QUANT_7_10, (100.0*QUANT_7_10)/((float) QUANT), 37);
  fprintf(txt, "\n  %2d alunos (%5.2f%c) com nota igual ou superior a 4.0 e"
      " inferior a 7.0", QUANT_4_7, (100.0*QUANT_4_7)/((float) QUANT), 37);
  fprintf(txt, "\n  %2d alunos (%5.2f%c) com nota inferior a 4.0",
		      QUANT_0_4, (100.0*QUANT_0_4)/((float) QUANT), 37);

  fclose(arq_dados);
  fclose(html);
  fclose(txt);

  printf("\n%c Arquivo %s criado (notas em ordem decrescente)", CAR, ArqTexto);
  printf("\n%c Arquivo %s criado (notas em ordem decrescente)\n",CAR, ArqHtml);
}

/* ----------------------------------------------------------------------- */

void LimpaLinha(char *linha) {

  int i = 0, fim;

  fim = strlen(linha);
  while(linha[i] == ' ') i++;
  Substr(linha, i, fim);
  i = 0;
  while(linha[i]) { if (linha[i] == '\n') linha[i] = '\0'; i++; }
}

/* ----------------------------------------------------------------------- */

int InterpretaArquivoTexto(char *ArqTexto) {

  FILE *arq_texto, *arq_dados, *arq_turma;
  t_turma turma;
  t_aluno aluno;
  char ident[100], linha[100], ArqTurma[100], ArqDados[100];
  int n_linha = 0, inicio, fim,
      xmatr = 0, xcurs = 0, xnome = 0, xnota = 0,
      n_linhas_errado = 1;;

  strcpy(turma.departamento, "UFPB - CCEN - Dep. Matematica");

  arq_texto = fopen(ArqTexto, "rt");
  if (arq_texto == NULL) {
    printf("\nERRO: arquivo %s nao pode ser aberto para leitura.\n",
							   ArqTexto);
    return 0;
  }

  while (fgets(linha, 100, arq_texto) != NULL) {
    LimpaLinha(linha);
    strcpy(ident, linha);
    inicio = Pos(' ', linha);
    fim = strlen(linha);
    Substr(linha, inicio, fim);
    LimpaLinha(linha);
    if (n_linha < LINHAS_NO_CABECALHO) {
      if (COMPSTRNI(ident, "CABE", 4))
	{n_linha++, LINHAS_NO_CABECALHO = atoi(linha);}
      else if (COMPSTRNI(ident, "CTAB", 4))
	{n_linha++, strcpy(COR_TABELA, linha);}
      else if (COMPSTRNI(ident, "CFUN", 4))
	{n_linha++, strcpy(COR_FUNDO, linha);}
      else if (COMPSTRNI(ident, "DEPA", 4))
	{n_linha++, strcpy(turma.departamento, linha);}
      else if (COMPSTRNI(ident, "CTEX", 4))
	{n_linha++, strcpy(COR_TEXTO, linha);}
      else if (COMPSTRNI(ident, "LETR", 4))
	{n_linha++, strcpy(TIPO_DE_LETRA, linha);}
      else if (COMPSTRNI(ident, "DISC", 4))
	{n_linha++, strcpy(turma.nome_da_disciplina, linha);}
      else if (COMPSTRNI(ident, "TURM", 4))
	{n_linha++, turma.turma = atoi(linha);}
      else if (COMPSTRNI(ident, "SALA", 4))
	{n_linha++, strcpy(turma.sala, linha);}
      else if (COMPSTRNI(ident, "HORA", 4))
	{n_linha++, strcpy(turma.turno, linha);}
      else if (COMPSTRNI(ident, "PROF", 4))
	{n_linha++, strcpy(turma.professor, linha);}
      else if (COMPSTRNI(ident, "MOLD", 4))
	{n_linha++, MOLDURA = atoi(linha);}
      else if (COMPSTRNI(ident, "LARG", 4))
	{n_linha++, LARGURA = atoi(linha);}
      else if (COMPSTRNI(ident, "PROV", 4))
	{n_linha++, PROVA = atoi(linha);}
      else if (COMPSTRNI(ident, "ESPA", 4))
	{n_linha++, ESPACAMENTO = atoi(linha);}

      if (n_linha == LINHAS_NO_CABECALHO) {
	sprintf(ArqTurma, "%s.TUR", NOME_BASE);
	Maiusculas(ArqTurma);
	arq_turma = fopen(ArqTurma, "wb");
	if (arq_turma == NULL) return 0;
	fwrite(&turma, sizeof(t_turma), 1, arq_turma);
	fclose(arq_turma);
	sprintf(ArqDados, "%s.DAT", NOME_BASE);
	Maiusculas(ArqDados);
	arq_dados = fopen(ArqDados, "wb");
	if (arq_dados == NULL) return 0;
      }

    } else {
      n_linhas_errado = 0;
      if (COMPSTRNI(ident, "MATR", 4))
	{xmatr = 1, strcpy(aluno.matricula, linha);}
      if (COMPSTRNI(ident, "CURS", 4))
	{xcurs = 1, aluno.curso = atoi(linha);}
      if (COMPSTRNI(ident, "ALUN", 4))
	{xnome = 1, strcpy(aluno.nome, linha);}
      if (COMPSTRNI(ident, "NOTA", 4)) {
	 if (linha[0] == '-' || linha[0] == 'f' || linha[0] == 'F') {
	   xnota = 0; QUANT_FALTOU++;
	 } else {
	   xnota = 1, aluno.nota[PROVA - 1] = atof(linha);
	   SOMA += aluno.nota[PROVA - 1];
	   if (aluno.nota[PROVA - 1] >= 7.0 && aluno.nota[PROVA - 1] <= 10.0)
	     QUANT_7_10++;
	   else if (aluno.nota[PROVA - 1] >= 4.0 && aluno.nota[PROVA-1] < 7.0)
	     QUANT_4_7++;
	   else if (aluno.nota[PROVA - 1] >= 0.0 && aluno.nota[PROVA-1] < 4.0)
	     QUANT_0_4++;
	 }
      }
      if (xmatr && xcurs && xnome && xnota) {
	QUANT++;
	xmatr = xcurs = xnome = xnota = 0;
	fwrite(&aluno, sizeof(t_aluno), 1, arq_dados);
      }
    }
  }

  fclose(arq_texto);
  fclose(arq_dados);
  if (n_linhas_errado) return 0;
  return 1;
}

/* ----------------------------------------------------------------------- */

void main(int argc, char **argv) {

  char nomeEntrada[100], nomeSaida[100];
  int ponto;

  if (argc <= 2) {
    printf("\n*** Converte um arquivo texto em tabelas em HTML ***\n");
    printf("(C) 1998, Lenimar N. Andrade  -  lenimar@mat.ufpb.br\n");
    printf("\nForma de usar: "
	     "T2H  Nome_Arq_Texto  Nome_Arq_Saida\n");
    printf("\nExemplo: C:\\> T2H  dados.txt  notas.htm\n");
    return;
  }

  strcpy(nomeEntrada, argv[1]);
  Maiusculas(nomeEntrada);
  if (!InterpretaArquivoTexto(nomeEntrada)) {
    printf("\nERRO no cabecalho do arquivo %s\n", nomeEntrada);
    return;
  }
  strcpy(nomeSaida, argv[2]);
  if ((ponto = Pos('.', nomeSaida)) > 0) Substr(nomeSaida, 0, ponto - 1);
  nomeSaida[7] = '\0';

  CriaArquivoEmOrdemAlfabetica(nomeSaida);
  CriaArquivoEmOrdemDecrescente(nomeSaida);
}

/* ----------------------------------------------------------------------- */

/*** FIM DE "T2H.C" ***/
